;********************************************************************
;                         Tomasz Jaboski                          *
;                 Mikrokontrolery PIC16F8x w praktyce               *
;                      Wydawnictwo BTC, www.btc.pl                  *
;********************************************************************
; Przykad 3.5.
; Zapisywanie danych do pamici EEPROM
	BCF STATUS,RP0		; wybr banku 0
	MOVLW adres
	MOVWF EEADR		; EEADR<-adres komrki w pamici EEPROM
	MOVF W,dana
	MOVWF EEDATA		; EEDATA<-bajt do zapisania (dana)

	BSF STATUS,RP0		; wybierz bank 1 (gdy rejestr INTCON i EECON1
				; znajduj si w banku 1)
	BCF INTCON,GIE		; zablokowanie przerwa
	BSF EECON1,WREN		; WREN=1  zezwolenie na zapisywanie 
				; pamici EEPROM

; pocztek sekcji niezbdnej do zapisania bajtu w pamici EEPROM
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xaa
	MOVWF EECON2
	BSF EECON1,WR		; WR=1  rozpoczcie zapisywania 
				; w pamici EEPROM
;koniec sekcji

	BSF INTCON,GIE		;odblokowanie przerwa

_sprwr	BTFSC EECON1,WR		; sprawdzanie bitu WR
	GOTO _sprwr		; WR=1
				; zapisanie do pamici EEPROM zakoczone pomylnie
	BCF EECON1,WREN		; WREN=0  brak zezwolenia na zapisywanie 
				; do pamici EEPROM
	BCF STATUS,RP0		; wybierz bank 0
