Listing 8.4. Procedura obsugi klawiatury matrycowej
;********************************************************************
; procedura przerwania obsugujcego klawiatur matrycow.
; Kod klawisza jest zwracany w rejestrze kod
; bit O_KL=0 sygnalizuje zidentyfikowanie wcinitego klawisza
;********************************************************************
				org 0004
_int			movwf w_temp			;w_temp <- w
				swapf status,w		;w <-status
				movwf st_temp		;st_temp <-w
				bcf RP0				;bank0
		
				bcf T0IF 				;zeruj znacznik przerwania od T0
				movlw.130				;aduj T0
				movwf tmr0

				btfss o_kl			;czy bit o_kl wyzerowany
				goto _odtworz		;poprzedni odczyt klawiatury nie zakoczony

				incf l_msek,f
				movf l_msek,w
				xorlw.20
				btfss Z				;nie mino 20 ms
				goto _odtworz

				clrf l_msek
				btfsc pu_kl		;sprawdzenie czy poprzednio klawisz puszczony
				goto _spr_pw			;klawisz puszczony


				clrf porta		;sprawdzenie czy wszystkie klawisze puszczone
				nop
				movf portb,w
				andlw 0f0h
				xorlw 0f0h
				btfsc Z
				bsf pu_kl				;klawisz puszczony
				movlw 1ch				;deaktywacja linii
				movwf porta
				goto _odtworz

_spr_pw		btfsc pw_kl			;czy ju byo sprawdzane wcinicie
				goto _spr_dr			;sprawdzenie drugi raz

				clrf porta			;sprawdzenie czy jaki klawisz wcinity
				nop
				movf portb,w
				andlw 0f0h
				xorlw 0f0h
				btfss Z
				bsf pw_kl				;znacznik - klawisz wcinity
				movlw 1ch
				movwf porta			;deaktywacja linii
				goto _odtworz
_spr_dr		clrw					;sprawdzenie ktry klawisz wcinity
				clrf l_kol
				call spr_kl			;sprawd czy klawisze wcinite
				btfss Z
				goto _tkod

				movlw.1
				movwf l_kol
				call spr_kl			;sprawd czy klawisze wcinite
				btfss Z
				goto _tkod

				movlw.2
				movwf l_kol
				call spr_kl			;sprawd czy klawisze wcinite
				btfsc Z
				goto _blad

_tkod			bcf o_kl				;sprawdzenie klawiatury zablokowane
										;do odczytania kodu
				bcf pu_kl				;wartoci pocztkowe bitw
				bcf pw_kl
				comf kod,f
				swapf kod,w
				andlw 0fh
				movwf kod

				movf l_kol,w
				btfsc Z
				goto _odtworz		;kod klawisza w zmiennej kod
				xorlw.1
				btfsc Z
				goto _kod_kol2
				movf kod,w
				addlw.16
				movwf kod
				goto _odtworz

_kod_kol2	movf kod,w
				addlw.8
				movwf kod
				goto _odtworz

_blad			bcf pu_kl				;zerowanie znacznikw
				bcf pw_kl
				;odtworzenie rejestrw W i status
_odtworz		swapf st_temp,w		;w <- st_temp
				movwf status			;status <- w
				swapf w_temp,f 		;w <- w_temp
				swapf w_temp,w
				retfie

_poz			addwf pcl,f
				dt	18h,14h,0ch

spr_kl 		call _poz				;aktywacja linii
				movwf porta
				nop
				nop
				movf portb,w			;czytanie linii RB4..RB7
				andlw 0f0h
				movwf kod				;zapisz
				movlw 1ch				;deaktywacja linii
				movwf porta	

				movf kod,w
				xorlw 0f0h			;sprawdzenie stanu klawisza

				return
